//+------------------------------------------------------------------+
//|                                       Nonlagma_EA_RB_V1.mq4      |
//|                            Rogrio Borges, Copyright 2016        |
//|                                          rogeriob28@gmail.com    | 
//+------------------------------------------------------------------+
#property copyright "Rogerio Borges,Copyright 2016"
#property link      "rogeriob28@gmail.com"
// You Need Custom Indicator named alma nonlagma_nrp_1_1.

enum displayLike
{
   dis_lines, // Display as lines
   dis_dots   // Display as dots
};
extern string Comentario = "Nonlagma EA RB V7 ";
extern bool   UseAutoMagic     = true;
extern int    ManualMagic      = 5010100;
//extern int    MagicNumber = 123456;  // Magic number to use for the EA
extern bool   EcnBroker   = false;   // Is your broker ECN/STP type of broker?
extern double LotSize     = 1;     // Lot size to use for trading
extern int    Slippage    = 1;       // Slipage to use when opening new orders
extern double StopLoss    = 9;     // Initial stop loss (in pips)
extern double TakeProfit  = 20;     // Initial take profit (in pips)

extern string dummy1      = "";      // .
extern string IndicadorNonlagma      = "Indicador Nonlagma";      // Settings for indicators
extern int    BarToUse    = 1;       // Bar to test (0, for still opened, 1 for first closed, and so on)
extern int                Length          = 5;             // Nonlag ma calculation length
extern ENUM_APPLIED_PRICE Price           = PRICE_CLOSE;    // Price to use
extern bool               alertsOn        = false;           // Turn alert on?
extern bool               alertsOnCurrent = false;           // Alerts on current (still opened) bar?
extern bool               alertsMessage   = false;           // Alerts should show pop-up message?
extern bool               alertsSound     = false;          // Alerts should play alert sound?
extern bool               alertsEmail     = false;          // Alerts shoyuld send an email?
extern displayLike        DisplayType     = dis_lines;      // What should the display be like?
extern bool               Interpolate     = false;           // Interpolate in multi time frame mode?
extern string IndicadorIXO      = "Indicador IXO";      //
extern int PeriodIXO = 15;
extern string dummy3      = "";      // . 
extern string dummy4      = "";      // General settings
extern string    stopheader="== Advanced Stops ==";
extern double    TrailingStop=100;
extern bool      TrailingStopOnlyProfit=false;
extern bool      TrailingStopRegular=true;
extern int       breakEvenAtProfit=0;
extern int       breakEvenShift=0;
extern bool      UsarLockProfit= true;
bool             StealthMode  = false;
extern double       LockProfit1  = 1;
extern double       LockProfit2  = 2;
extern double       LockProfit3  = 3;
extern double       LockProfit4  = 4;
extern double       LockProfit5  = 5;
extern double       LockProfit6  = 6;
extern double       LockProfit7  = 7;
extern double       LockProfit8  = 8;
extern double       LockProfit9  = 10;
extern double       LockProfit10 = 20;
extern bool      DisplayInfo = true;    // Dislay info

bool dummyResult;
double PointRatio = 1;
double myPoint;
int digits=MarketInfo(Symbol(),MODE_DIGITS);
int MagicNumber;
int StopLevel;
//EA name
string  EANAME="NonlagmaV7";
string  EASHORTNAME="NonlagmaV7";
//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()   
{ 
//---------

               
// Unique sting id.    
   string id = WindowExpertName() + Symbol() + Period();
    
  if (UseAutoMagic)
    
   // If there isn't already a Global Variable with the id in wich search for the MagicNumber create it  
   if(!GlobalVariableCheck(id))
   {
      MagicNumber = WindowHandle(Symbol(),0);   
      GlobalVariableSet(id,MagicNumber);
   }
   else // Just get the MagicNumber for the unique id
   {
      MagicNumber = GlobalVariableGet(id);
   }
   else  MagicNumber = ManualMagic;   
               
  digits=MarketInfo(Symbol(),MODE_DIGITS);     
   
   if (digits==2 || digits==4) PointRatio = 1;
   if (digits==3 || digits==5) PointRatio = 10;
   if (digits==6)             PointRatio = 100;
 //  myPoint  = MarketInfo(Symbol(),MODE_POINT) * PointRatio;  
        
  
  int JPY_pair=StringFind(Symbol(),"JPY",0);
  if(JPY_pair==-1){switch(digits)
                  { case 4:{myPoint=Point;return(myPoint);}
                    case 5:{myPoint=10*Point;return(myPoint);}
                  }
                 }
  if(JPY_pair==3){myPoint=0.01;return(myPoint);}
StopLevel = MarketInfo(Symbol(), MODE_STOPLEVEL) + MarketInfo(Symbol(), MODE_SPREAD);
  
   //Calculo de Ponto
   if (Point == 0.00001) myPoint = 0.0001;
   else {
      if (Point == 0.001) myPoint = 0.01;
      else myPoint = Point;
   }

//---------
return(0); 
}
int deinit() { return(0); }

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

#define _doNothing 0
#define _doBuy     1
#define _doSell    2
int start()
{

   int doWhat = _doNothing;
   double d22=(0);   
   bool timingUp=false;
   bool timingDn=false;
   int OrdersOpen=0, buyOrders=0, sellOrders=0, pendingOrders=0;

   checkOrderStatus(OrdersOpen,buyOrders,sellOrders,pendingOrders);
   advancedStopManager(OrdersOpen);
      double nonlagma_trend_current  =iCustom(NULL,0,"nonlagma_nrp_1_1",0,Length,Price,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,false,3,BarToUse);
      double nonlagma_trend_previous = iCustom(NULL,0,"nonlagma_nrp_1_1",0,Length,Price,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,false,3,BarToUse+1);
      
      //ixo
      double diIXO10=iCustom(NULL,0,"I_XO_A_H",PeriodIXO,0,0);
      double diIXO21=iCustom(NULL,0,"I_XO_A_H",PeriodIXO,1,0);
      
      //diIXO10 > d22 // Buy
     // diIXO21< d22 // Sell
     
     //Timing Indicator
     //Buy
     
      if (nonlagma_trend_current!=nonlagma_trend_previous)
         if (nonlagma_trend_current == 1 && diIXO10>d22) doWhat = _doBuy;
         if (nonlagma_trend_current ==-1 && diIXO21<d22)  doWhat = _doSell;
         if (doWhat==_doNothing && !DisplayInfo) return(0);
         
   //
   //
   //
   //
   //
   
   int    openedBuys    = 0;
   int    openedSells   = 0;
   double currentProfit = 0;
   for (int i = OrdersTotal()-1; i>=0; i--)
   {
      if (!OrderSelect(i,SELECT_BY_POS,MODE_TRADES)) continue;
      if (OrderSymbol()      != Symbol())            continue;
      if (OrderMagicNumber() != MagicNumber)         continue;

      //
      //
      //
      //
      //
      
      if (DisplayInfo) currentProfit += OrderProfit()+OrderCommission()+OrderSwap();
         
         //
         //
         //
         //
         //
         
         if (OrderType()==OP_BUY)
            if (doWhat==_doSell)
                  { RefreshRates(); if (!OrderClose(OrderTicket(),OrderLots(),Bid,Slippage,Orange)) openedBuys++; }
            else  openedBuys++;
         if (OrderType()==OP_SELL)
            if (doWhat==_doBuy)
                  { RefreshRates(); if (!OrderClose(OrderTicket(),OrderLots(),Ask,Slippage,Green)) openedSells++; }
            else  openedSells++;            
   }
   if (DisplayInfo) Comment("Current profit : "+DoubleToStr(currentProfit,2)+" "+AccountCurrency() + " Magic: " +MagicNumber); if (doWhat==_doNothing) return(0);

   //
   //
   //
   //
   //

   if (doWhat==_doBuy && openedBuys==0)
      {
         RefreshRates();
         double stopLossBuy   = 0; if (StopLoss>0)   stopLossBuy   = Ask-StopLoss*myPoint; //*MathPow(10,Digits%2);
         double takeProfitBuy = 0; if (TakeProfit>0) takeProfitBuy = Ask+TakeProfit*myPoint; //*MathPow(10,Digits%2);
         if (EcnBroker)
         {
            int ticketb = OrderSend(Symbol(),OP_BUY,LotSize,Ask,Slippage,0,0,EASHORTNAME+"_"+Symbol()+"("+GetChartTimeFrame()+")_S",MagicNumber,0,Blue);
            if (ticketb>-1)
              dummyResult = OrderModify(ticketb,OrderOpenPrice(),stopLossBuy,takeProfitBuy,0,CLR_NONE);
         }
         else dummyResult = OrderSend(Symbol(),OP_BUY,LotSize,Ask,Slippage,stopLossBuy,takeProfitBuy,EASHORTNAME+"_"+Symbol()+"("+GetChartTimeFrame()+")_S",MagicNumber,0,Blue);
      }
   if (doWhat==_doSell && openedSells==0)
      {
         RefreshRates();
         double stopLossSell   = 0; if (StopLoss>0)   stopLossSell   = Bid+StopLoss*myPoint; //*MathPow(10,Digits%2);
         double takeProfitSell = 0; if (TakeProfit>0) takeProfitSell = Bid-TakeProfit*myPoint; //*MathPow(10,Digits%2);
         if (EcnBroker)
         {
            int tickets = OrderSend(Symbol(),OP_SELL,LotSize,Bid,Slippage,0,0,EASHORTNAME+"_"+Symbol()+"("+GetChartTimeFrame()+")_S",MagicNumber,0,Red);
            if (tickets>-1)
              dummyResult = OrderModify(tickets,OrderOpenPrice(),stopLossSell,takeProfitSell,0,CLR_NONE);
         }
         else dummyResult = OrderSend(Symbol(),OP_SELL,LotSize,Bid,Slippage,stopLossSell,takeProfitSell,EASHORTNAME+"_"+Symbol()+"("+GetChartTimeFrame()+")_S",MagicNumber,0,Red);
      }
   return(0);
} // Fim start

//-------------------------------------------------------------------
void regularTrailingStop() 
{
   int cnt, total = OrdersTotal();
   
   for(cnt=0;cnt<total;cnt++)
     {
      if(OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES))
       {

        if(OrderType()<=OP_SELL && OrderSymbol()==Symbol() && OrderMagicNumber()==MagicNumber )
          {if(TrailingStop>0)  
           {if(OrderType()==OP_BUY)
              {if(OrderStopLoss()<Bid-myPoint*TrailingStop)
                 { dummyResult=OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(Bid-myPoint*TrailingStop,digits),OrderTakeProfit(),0,Green); 
                 }}}
            else
              {if((OrderStopLoss()>(Ask+myPoint*TrailingStop)) || (OrderStopLoss()==0))
                 { dummyResult=OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(Ask+myPoint*TrailingStop,digits),OrderTakeProfit(),0,Red); 
                 }}}}}
}

//+------------------------------------------------------------------+

void onlyProfitTrailingStop() 
   {
   
   int cnt, total = OrdersTotal();

   for(cnt=0;cnt<total;cnt++)
     {
      if(OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES))
      {

        if(OrderType()<=OP_SELL && OrderSymbol()==Symbol() && OrderMagicNumber()==MagicNumber )
          {if(TrailingStop>0)  
           {if(OrderType()==OP_BUY)
              {if(Bid-OrderOpenPrice()>myPoint*TrailingStop)
                 {if(OrderStopLoss()<Bid-myPoint*TrailingStop)
                    { dummyResult=OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(Bid-myPoint*TrailingStop,digits),OrderTakeProfit(),0,Green); 
                        }}}}
            else
              {if((OrderOpenPrice()-Ask)>(myPoint*TrailingStop))
                 {if((OrderStopLoss()>(Ask+myPoint*TrailingStop)) || (OrderStopLoss()==0))
                    { dummyResult=OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(Ask+myPoint*TrailingStop,digits),OrderTakeProfit(),0,Red); 
                        }}}}}}}
   
//+------------------------------------------------------------------+



//+------------------------------------------------------------------+
void breakEvenManager() 

   {
   
   for(int cnt=0;cnt<OrdersTotal();cnt++)
     {
      if(OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES))
      {

        if(OrderType()<=OP_SELL && OrderSymbol()==Symbol() && OrderMagicNumber()==MagicNumber )
         {if(breakEvenAtProfit>0)  
           {if(OrderType()==OP_BUY)
              {if(Bid-OrderOpenPrice()>=myPoint*breakEvenAtProfit)
                 {if(OrderStopLoss()!=OrderOpenPrice() + breakEvenShift*myPoint)
                    { dummyResult=OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()+ breakEvenShift*myPoint,OrderTakeProfit(),0,Green); 
                        }}}}
             else
              {if((OrderOpenPrice()-Ask)>(myPoint*breakEvenAtProfit))
                 {if(OrderStopLoss()!=OrderOpenPrice() - breakEvenShift*myPoint)
                    { dummyResult=OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()- breakEvenShift*myPoint,OrderTakeProfit(),0,Red); 
                        }}}}}}}
   
//+------------------------------------------------------------------+
void advancedStopManager(int OrdersOpen) 
{
   if (TrailingStopOnlyProfit && TrailingStopRegular)
      {Print("Both Trailing Stops are enabled.  Defaulted to Regular TS.");}
    
   if (OrdersOpen >= 1)
   {
      if(UsarLockProfit) Locking();

      if (breakEvenAtProfit>0)
         breakEvenManager();
      if (TrailingStopRegular)
          regularTrailingStop();
      else if (TrailingStopOnlyProfit)
          onlyProfitTrailingStop();
      
    }
}
//+---------------------------------------------------------------------------+

//+------------------------------------------------------------------+
void Locking()
{
  //---- Variable
 int OPSell=0, OPBuy=0, OPtotal=0;
 int i;
 double harga;
 RefreshRates();
 for(i= 0; i < OrdersTotal(); i++)
   { 
      if(OrderSelect(i, SELECT_BY_POS,MODE_TRADES) == true)
      { 
         if (OrderSymbol() == Symbol()&& OrderCloseTime() == 0) 
         {
               harga = OrderOpenPrice();
               if(OrderType() == OP_BUY)  OPBuy++; 
               if(OrderType() == OP_SELL) OPSell++;
         } 
      } 
   }
   OPtotal = OPBuy + OPSell;
// End Variable Code
  if(OPtotal > 0)
  {
     double Pips_Buy            = Bid-OrderOpenPrice();
     double Pips_Sell           = OrderOpenPrice()-Ask;
     double Pips_Lock1          = LockProfit1 * myPoint;
     double Pips_Lock2          = LockProfit2 * myPoint;
     double Pips_Lock3          = LockProfit3 * myPoint;
     double Pips_Lock4          = LockProfit4 * myPoint;
     double Pips_Lock5          = LockProfit5 * myPoint;
     double Pips_Lock6          = LockProfit6 * myPoint;
     double Pips_Lock7          = LockProfit7 * myPoint;
     double Pips_Lock8          = LockProfit8 * myPoint;
     double Pips_Lock9          = LockProfit9 * myPoint;
     double Pips_Lock10         = LockProfit10 * myPoint;
 
     
     if(OPBuy > 0 && OPSell == 0)
       {
        if (Pips_Buy > Pips_Lock1 && Pips_Buy < Pips_Lock2)
        {   if(StealthMode==false){ dummyResult=OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()+Pips_Lock1,OrderTakeProfit(),0,CLR_NONE); }
            if(StealthMode==true)
              { if (Close[1]<Close[2] && Pips_Buy >= Pips_Lock1 && Pips_Buy < Pips_Lock2) { close_all(); }
              }
        }
        if (Pips_Buy > Pips_Lock2 && Pips_Buy < Pips_Lock3)
        {   if(StealthMode==false){ dummyResult=OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()+Pips_Lock2,OrderTakeProfit(),0,CLR_NONE); }
            if(StealthMode==true)
              { if (Close[1]<Close[2] && Pips_Buy >= Pips_Lock2 && Pips_Buy < Pips_Lock3) { close_all(); }
              }
        }
        if (Pips_Buy > Pips_Lock3 && Pips_Buy < Pips_Lock4)
        {   if(StealthMode==false){ dummyResult=OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()+Pips_Lock3,OrderTakeProfit(),0,CLR_NONE); }
            if(StealthMode==true)
              { if (Close[1]<Close[2] && Pips_Buy >= Pips_Lock3 && Pips_Buy < Pips_Lock3) { close_all(); }
              }
        }
        if (Pips_Buy > Pips_Lock4 && Pips_Buy < Pips_Lock5)
        {   if(StealthMode==false){ dummyResult=OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()+Pips_Lock4,OrderTakeProfit(),0,CLR_NONE); }
            if(StealthMode==true)
              { if (Close[1]<Close[2] && Pips_Buy >= Pips_Lock4 && Pips_Buy < Pips_Lock4) { close_all(); }
              }
        }
        if (Pips_Buy > Pips_Lock5 && Pips_Buy < Pips_Lock6)
        {   if(StealthMode==false){ dummyResult=OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()+Pips_Lock5,OrderTakeProfit(),0,CLR_NONE); }
            if(StealthMode==true)
              { if (Close[1]<Close[2] && Pips_Buy >= Pips_Lock5 && Pips_Buy < Pips_Lock6) { close_all(); }
              }
        }
        if (Pips_Buy > Pips_Lock6 && Pips_Buy < Pips_Lock7)
        {   if(StealthMode==false){ dummyResult=OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()+Pips_Lock6,OrderTakeProfit(),0,CLR_NONE); }
            if(StealthMode==true)
              { if (Close[1]<Close[2] && Pips_Buy >= Pips_Lock6 && Pips_Buy < Pips_Lock6) { close_all(); }
              }
        }
        if (Pips_Buy > Pips_Lock7 && Pips_Buy < Pips_Lock8)
        {   if(StealthMode==false){ dummyResult=OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()+Pips_Lock7,OrderTakeProfit(),0,CLR_NONE); }
            if(StealthMode==true)
              { if (Close[1]<Close[2] && Pips_Buy >= Pips_Lock7 && Pips_Buy < Pips_Lock8) { close_all(); }
              }
        }
        if (Pips_Buy > Pips_Lock8 && Pips_Buy < Pips_Lock9)
        {   if(StealthMode==false){ dummyResult=OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()+Pips_Lock8,OrderTakeProfit(),0,CLR_NONE); }
            if(StealthMode==true)
              { if (Close[1]<Close[2] && Pips_Buy >= Pips_Lock8 && Pips_Buy < Pips_Lock9) { close_all(); }
              }
        }
        if (Pips_Buy > Pips_Lock9 && Pips_Buy < Pips_Lock10)
        {   if(StealthMode==false){ dummyResult=OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()+Pips_Lock9,OrderTakeProfit(),0,CLR_NONE); }
            if(StealthMode==true)
              { if (Close[1]<Close[2] && Pips_Buy >= Pips_Lock9 && Pips_Buy < Pips_Lock10) { close_all(); }
              }
        }
        if (Pips_Buy > Pips_Lock10)
        {   if(StealthMode==false){ dummyResult=OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()+Pips_Lock10,OrderTakeProfit(),0,CLR_NONE); }
            if(StealthMode==true)
              { if (Close[1]<Close[2] && Pips_Buy >= Pips_Lock10) { close_all(); }
              }
        }
     }//if op buy>0
     
     if(OPBuy == 0 && OPSell > 0)
     {
        if (Pips_Sell > Pips_Lock1 && Pips_Sell < Pips_Lock2)
        {   if(StealthMode==false){ dummyResult=OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()-Pips_Lock1,OrderTakeProfit(),0,CLR_NONE); }
            if(StealthMode==true)
              { if (Close[1]>Close[2] && Pips_Sell >= Pips_Lock1 && Pips_Sell < Pips_Lock2) { close_all(); }
              }
        }
        if (Pips_Sell > Pips_Lock2 && Pips_Sell < Pips_Lock3)
        {   if(StealthMode==false){ dummyResult=OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()-Pips_Lock2,OrderTakeProfit(),0,CLR_NONE); }
            if(StealthMode==true)
              { if (Close[1]>Close[2] && Pips_Sell >= Pips_Lock2 && Pips_Buy < Pips_Sell) { close_all(); }
              }
        }
        if (Pips_Sell > Pips_Lock3 && Pips_Sell < Pips_Lock4)
        {   if(StealthMode==false){ dummyResult=OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()-Pips_Lock3,OrderTakeProfit(),0,CLR_NONE); }
            if(StealthMode==true)
              { if (Close[1]>Close[2] && Pips_Sell >= Pips_Lock3 && Pips_Sell < Pips_Lock3) { close_all(); }
              }
        }
        if (Pips_Sell > Pips_Lock4 && Pips_Sell < Pips_Lock5)
        {   if(StealthMode==false){ dummyResult=OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()-Pips_Lock4,OrderTakeProfit(),0,CLR_NONE); }
            if(StealthMode==true)
              { if (Close[1]>Close[2] && Pips_Sell >= Pips_Lock4 && Pips_Sell < Pips_Lock4) { close_all(); }
              }
        }
        if (Pips_Sell > Pips_Lock5 && Pips_Sell < Pips_Lock6)
        {   if(StealthMode==false){ dummyResult=OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()-Pips_Lock5,OrderTakeProfit(),0,CLR_NONE); }
            if(StealthMode==true)
              { if (Close[1]>Close[2] && Pips_Sell >= Pips_Lock5 && Pips_Sell < Pips_Lock6) { close_all(); }
              }
        }
        if (Pips_Buy > Pips_Lock6 && Pips_Buy < Pips_Lock7)
        {   if(StealthMode==false){ dummyResult=OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()-Pips_Lock6,OrderTakeProfit(),0,CLR_NONE); }
            if(StealthMode==true)
              { if (Close[1]>Close[2] && Pips_Buy >= Pips_Lock6 && Pips_Buy < Pips_Lock6) { close_all(); }
              }
        }
        if (Pips_Buy > Pips_Lock7 && Pips_Buy < Pips_Lock8)
        {   if(StealthMode==false){ dummyResult=OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()-Pips_Lock7,OrderTakeProfit(),0,CLR_NONE); }
            if(StealthMode==true)
              { if (Close[1]>Close[2] && Pips_Buy >= Pips_Lock7 && Pips_Buy < Pips_Lock8) { close_all(); }
              }
        }
        if (Pips_Buy > Pips_Lock8 && Pips_Buy < Pips_Lock9)
        {   if(StealthMode==false){ dummyResult=OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()-Pips_Lock8,OrderTakeProfit(),0,CLR_NONE); }
            if(StealthMode==true)
              { if (Close[1]>Close[2] && Pips_Buy >= Pips_Lock8 && Pips_Buy < Pips_Lock9) { close_all(); }
              }
        }
        if (Pips_Buy > Pips_Lock9 && Pips_Buy < Pips_Lock10)
        {   if(StealthMode==false){ dummyResult=OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()-Pips_Lock9,OrderTakeProfit(),0,CLR_NONE); }
            if(StealthMode==true)
              { if (Close[1]>Close[2] && Pips_Buy >= Pips_Lock9 && Pips_Buy < Pips_Lock10) { close_all(); }
              }
        }
        if (Pips_Buy > Pips_Lock10)
        {   if(StealthMode==false){ dummyResult=OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()-Pips_Lock10,OrderTakeProfit(),0,CLR_NONE); }
            if(StealthMode==true)
              { if (Close[1]>Close[2] && Pips_Buy >= Pips_Lock10) { close_all(); }
              }
        }
       }//if op sell>0
  }//if op total>0
}//void
//---------------------------------------------------------------------------
void close_all()
{
    int total=OrdersTotal(), i;
    for(i=0; i<total; i++)
    {
        close_ordem();
    }
}
//+------------------------------------------------------
void close_ordem()
  {
    RefreshRates();
    for(int cnt=OrdersTotal()-1; cnt>=0; cnt--)
    {
        if(OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES))
        {
           if(OrderType()==OP_SELL) {if(!OrderClose(OrderTicket(),OrderLots(),MarketInfo(Symbol(),MODE_ASK),3,CLR_NONE)) Print("last error code = ",GetLastError());}
           if(OrderType()==OP_BUY)  {if(!OrderClose(OrderTicket(),OrderLots(),MarketInfo(Symbol(),MODE_BID),3,CLR_NONE))  Print("last error code = ",GetLastError());}
        }
    }
  }
  
  //+------------------------------------------------------------------+

 
void checkOrderStatus(int& OrdersOpen,int& buyOrders,int& sellOrders,int& pendingOrders)
{
   for(int cnt=OrdersTotal();cnt>=0;cnt--)
     {
      if(OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES))
      {
        if( OrderSymbol()==Symbol() && OrderMagicNumber()==MagicNumber /**/ )
        {  
         if (OrderType()==OP_BUY)
            {buyOrders++; OrdersOpen++;}
         else if (OrderType()==OP_SELL)
            {sellOrders++; OrdersOpen++;}
         else
            {pendingOrders++; OrdersOpen++;}
        }
       }
     }
}

//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//| GetChartTimeFrame                                                |
//+------------------------------------------------------------------+
string GetChartTimeFrame()
{   
   //ChartTimeFrame
   string TimeFrame ;
   switch(Period())
   {
      case 1:     TimeFrame = "M1";break;
      case 5:     TimeFrame = "M5"; break;
      case 15:    TimeFrame = "M15"; break;
      case 30:    TimeFrame = "M30"; break;
      case 60:    TimeFrame = "H1"; break;
      case 240:   TimeFrame = "H4"; break;
      case 1440:  TimeFrame = "D1";  break;
      case 10080: TimeFrame = "W1"; break;
      case 43200: TimeFrame = "MN1"; break;
   }
   return(TimeFrame);
}
